(function() {
  var BufferStream, Stream, buffertools, concat_, isArray, isBuffer, max, min, split, _ref, _ref2;
  var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; }, __hasProp = Object.prototype.hasOwnProperty, __extends = function(child, parent) {
    for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; }
    function ctor() { this.constructor = child; }
    ctor.prototype = parent.prototype;
    child.prototype = new ctor;
    child.__super__ = parent.prototype;
    return child;
  }, __slice = Array.prototype.slice;
  Stream = require('stream').Stream;
  buffertools = require('buffertools');
  _ref = [Math.min, Math.max], min = _ref[0], max = _ref[1];
  _ref2 = [Array.isArray, Buffer.isBuffer], isArray = _ref2[0], isBuffer = _ref2[1];
  split = function() {
    var buflen, can_split, cur, found, i, pos, rest, splitter, _i, _len, _ref3, _results;
    if (!this.buffer.length) {
      return;
    }
    can_split = true;
    _results = [];
    while (can_split) {
      cur = null;
      pos = buflen = this.buffer.length;
      _ref3 = this.splitters;
      for (_i = 0, _len = _ref3.length; _i < _len; _i++) {
        splitter = _ref3[_i];
        if (buflen < splitter.length) {
          continue;
        }
        i = buffertools.indexOf.call(this.buffer, splitter);
        if (i !== -1 && i < pos && i < buflen) {
          cur = splitter;
          pos = i;
        }
      }
      can_split = cur !== null;
      if (!can_split) {
        break;
      }
      found = new Buffer(min(buflen, pos));
      rest = new Buffer(max(0, buflen - cur.length - pos));
      this.buffer.copy(found, 0, 0, min(buflen, pos));
      this.buffer.copy(rest, 0, min(buflen, pos + cur.length));
      this.buffer = rest;
      this.emit('split', found, cur);
      if (!this.enabled || this.buffer.length === 0) {
        break;
      }
    }
    return _results;
  };
  BufferStream = (function() {
    __extends(BufferStream, Stream);
    function BufferStream(encoding) {
      this.destroy = __bind(this.destroy, this);
      this.end = __bind(this.end, this);
      this.write = __bind(this.write, this);
      this.split = __bind(this.split, this);
      this.flush = __bind(this.flush, this);
      this.disable = __bind(this.disable, this);
      this.enable = __bind(this.enable, this);
      this.resume = __bind(this.resume, this);
      this.pause = __bind(this.pause, this);
      this.setEncoding = __bind(this.setEncoding, this);
      this.destroySoon = __bind(this.destroySoon, this);
      this.toString = __bind(this.toString, this);
      this.getBuffer = __bind(this.getBuffer, this);      this.finished = false;
      this.paused = false;
      this.enabled = true;
      this.writable = true;
      this.readable = true;
      this.splitters = [];
      this.buffer = new Buffer(0);
      this.encoding = encoding != null ? encoding : 'utf8';
      BufferStream.__super__.constructor.apply(this, arguments);
    }
    BufferStream.prototype.getBuffer = function() {
      return this.buffer;
    };
    BufferStream.prototype.toString = function() {
      return this.buffer.toString();
    };
    BufferStream.prototype.destroySoon = function() {
      return this.destroy();
    };
    BufferStream.prototype.setEncoding = function(encoding) {
      return this.encoding = encoding;
    };
    BufferStream.prototype.pause = function() {
      this.paused = true;
      return this.emit('pause');
    };
    BufferStream.prototype.resume = function() {
      this.paused = false;
      this.emit('resume');
      if (!this.enabled) {
        this.flush();
      }
      if (this.finished) {
        this.emit('end');
        return this.emit('close');
      }
    };
    BufferStream.prototype.enable = function() {
      return this.enabled = true;
    };
    BufferStream.prototype.disable = function() {
      this.enabled = false;
      if (!this.paused) {
        return this.flush();
      }
    };
    BufferStream.prototype.flush = function() {
      if (this.buffer.length) {
        this.emit('data', this.buffer);
      }
      return this.buffer = new Buffer(0);
    };
    BufferStream.prototype.split = function() {
      var args, callback, splitter;
      args = 1 <= arguments.length ? __slice.call(arguments, 0) : [];
      if (args.length === 1 && isArray(args[0])) {
        args = args[0];
      }
      if (args.length === 2 && typeof args[1] === 'function') {
        splitter = args[0], callback = args[1];
        this.splitters.push(splitter);
        return this.on('split', function(_, token) {
          if (token === splitter) {
            return callback.apply(this, arguments);
          }
        });
      }
      return this.splitters = this.splitters.concat(args);
    };
    BufferStream.prototype.write = function(buffer, encoding) {
      if (!this.writable) {
        this.emit('error', new Error("Stream is not writable."));
      }
      if (isBuffer(buffer)) {} else if (typeof buffer === 'string') {
        buffer = new Buffer(buffer, encoding != null ? encoding : this.encoding);
      } else {
        this.emit('error', new Error("Argument should be either a buffer or a string."));
      }
      if (this.enabled || this.paused) {
        this.buffer = concat_(this.buffer, buffer);
        if (this.splitters.length) {
          split.call(this);
        }
      } else if (!this.paused) {
        this.emit('data', buffer);
      }
      return true;
    };
    BufferStream.prototype.end = function(buffer, encoding) {
      if (buffer) {
        this.write(buffer, encoding);
      }
      this.writable = false;
      this.finished = true;
      if (!this.paused) {
        if (!this.enabled) {
          this.flush();
        }
        this.emit('end');
        return this.emit('close');
      }
    };
    BufferStream.prototype.destroy = function() {
      this.readable = false;
      return this.writable = false;
    };
    return BufferStream;
  })();
  BufferStream.concat_buffers = concat_ = function() {
    var args, buffer, buffers, input, length, pos, result, _i, _j, _len, _len2;
    args = 1 <= arguments.length ? __slice.call(arguments, 0) : [];
    length = 0;
    buffers = [];
    for (_i = 0, _len = args.length; _i < _len; _i++) {
      input = args[_i];
      if (Buffer.isBuffer(input)) {
        length += input.length;
        buffers.push(input);
      }
    }
    pos = 0;
    result = new Buffer(length);
    for (_j = 0, _len2 = buffers.length; _j < _len2; _j++) {
      buffer = buffers[_j];
      buffer.copy(result, pos);
      pos += buffer.length;
    }
    return result;
  };
  module.exports = BufferStream;
}).call(this);
